      double precision function fhf2f(itb, imu, iml, imr, imbr,
     $        iat, iab, img2, img3, ima,
     $   imt, imb, itp)
     
      implicit real*8(a-z)

      double precision itb,imu,iml,imr,imbr,
     $                    iat,iab,img2,img3,ima,imt,imb
      integer itp
      double precision mlhlle1, mlhlle2, 
     $       mlhllediag1, mlhllediag2, mhhllediag1, mhhllediag2,
     $       alphadiag1, alphadiag2, mhptree, mhp
      integer selec2,selec3
      double precision delrholimit, delrholimitnew, delrhores,
     $                 delrho1loop, delrho2loopgluon,
     $                  delrho2loopgluino
      double precision msusytrnew
      double precision mw, mz, sw2, mt, mtrun, mb, as, alphasmz, gs, 
     $                 el, gf
      double precision xmw, xmz, xmt
      double precision cf, eps, pi
      complex*16 i
      double precision  MSt1, MSt2, stt, ctt, delmst,
     $                  MSb1, MSb2, stb, ctb,
     $                  qt1, qt2, qts, qb1, qb2, qbs,
     $                  msusy, msusytl, msusytr, msusybl, msusybr,
     $                  mtlr, mblr, au, ad, 
     $                  mmm, mgl, mue, 
     $                  beta, alpha, tb, ma

      common /smpara/ mw, mz, sw2, mt, mtrun, mb, as, alphasmz, gs, 
     $                el, gf
      common /smpara1/ xmw,xmz,xmt
      common /para/ cf, eps, pi, i
      common /susypara/ MSt1, MSt2, stt, ctt, delmst,
     $                  MSb1, MSb2, stb, ctb,
     $                  msusy, msusytl, msusytr, msusybl, msusybr,
     $                  mtlr, mblr, au, ad, 
     $                  mmm, mgl, mue, 
     $                  beta, alpha, tb, ma
      common /selec/ selec2, selec3
      common/higgsmass/mhh, mlh
      common /lle/ mlhlle1, mlhlle2,
     $             mlhllediag1, mlhllediag2, mhhllediag1, mhhllediag2,
     $             alphadiag1, alphadiag2, mhptree, mhp

      double precision jtb,jmu,jml,jmr,jat,jma,jmt,jmbr,
     $            jab,jmg3,jmg2,jmb
      common/dsav/ jtb,jmu,jml,jmr,jat,jma,jmt,jmbr,
     $  jab,jmg3,jmg2,jmb

      if(itb.ne.jtb .or. imu.ne.jmu .or. iml.ne.jml
     $ .or. imr.ne.jmr .or. iat.ne.jat .or. ima.ne.jma
     $ .or. imt.ne.jmt .or. imb.ne.jmb .or. imbr.ne.jmbr
     $ .or. jab.ne.iab .or. img2.ne.jmg2 .or. img3.ne.jmg3) then
            
      tb=itb
      mue=imu
      msusytl=iml
      msusytr=imr
      msusybr=imbr
      mtlr=iat
      mblr=iab
      mb=imb
      mt=imt
      mgl=img3
      ma=ima
      mmm=img2
      
      jtb=itb
      jmu=imu
      jml=iml
      jmr=imr
      jmbr=imbr
      jat=iat
      jab=iab
      jma=ima
      jmg2=img2
      jmg3=img3
      jmt=imt
      jmb=imb
      
      call FeynHiggsFast()
      endif
            
      if(itp.eq.1) fhf2f=mlhllediag2
      if(itp.eq.2) fhf2f=mhhllediag2
      if(itp.eq.3) fhf2f=sin(alphadiag2)
      if(itp.eq.4) fhf2f=cos(alphadiag2)
      if(itp.eq.5) fhf2f=mhp
      return
      end
      
      subroutine FeynHiggsFast()

c --------------------------------------------------------------
c
c     FeynHiggsFast
c     =============
c      
c       Calculation of the masses of the neutral CP-even
c       Higgs bosons in the MSSM
c       
c       Author: Sven Heinemeyer 
c       
c       Based on hep-ph/9903404
c       by S. Heinemeyer, W. Hollik, G. Weiglein
c       Based also on hep-ph/9803277, hep-ph/9807423, hep-ph/9812472,
c                     hep-ph/9910283
c       by S. Heinemeyer, W. Hollik, G. Weiglein
c       and on hep-ph/0001002
c       by M. Carena, H. Haber, S. Heinemeyer, W. Hollik,
c          C. Wagner and G. Weiglein
c      
c       In case of problems or questions,
c       contact Sven Heinemeyer 
c       email: Sven.Heinemeyer@desy.de
c       
c       FeynHiggs homepage:
c       http://www-itp.physik.uni-karlsruhe.de/feynhiggs/
c
c --------------------------------------------------------------


      implicit real*8(a-z)
      double precision mlhlle1, mlhlle2, 
     $       mlhllediag1, mlhllediag2, mhhllediag1, mhhllediag2,
     $       alphadiag1, alphadiag2, mhptree, mhp
      integer selec2,selec3
      double precision delrholimit, delrholimitnew, delrhores,
     $                 delrho1loop, delrho2loopgluon,
     $                  delrho2loopgluino
      double precision msusytrnew
      double precision mw, mz, sw2, mt, mtrun, mb, as, alphasmz, gs, 
     $                 el, gf
      double precision xmw, xmz, xmt
      double precision cf, eps, pi
      complex*16 i
      double precision  MSt1, MSt2, stt, ctt, delmst,
     $                  MSb1, MSb2, stb, ctb,
     $                  qt1, qt2, qts, qb1, qb2, qbs,
     $                  msusy, msusytl, msusytr, msusybl, msusybr,
     $                  mtlr, mblr, au, ad, 
     $                  mmm, mgl, mue, 
     $                  beta, alpha, tb, ma

      common /smpara/ mw, mz, sw2, mt, mtrun, mb, as, alphasmz, gs, 
     $                el, gf
      common /smpara1/ xmw,xmz,xmt
      common /para/ cf, eps, pi, i
      common /susypara/ MSt1, MSt2, stt, ctt, delmst,
     $                  MSb1, MSb2, stb, ctb,
     $                  msusy, msusytl, msusytr, msusybl, msusybr,
     $                  mtlr, mblr, au, ad, 
     $                  mmm, mgl, mue, 
     $                  beta, alpha, tb, ma
      common /selec/ selec2, selec3
      common/higgsmass/mhh, mlh
      common /lle/ mlhlle1, mlhlle2,
     $             mlhllediag1, mlhllediag2, mhhllediag1, mhhllediag2,
     $             alphadiag1, alphadiag2, mhptree, mhp


c ----------------------------------------------------------------
c setting the SM parameters 
c ----------------------------------------------------------------

      pi = 3.14159265897d0

      mz  = 91.187d0
      mw =  80.39d0
      gf = 1.16639d-5
      as = .1095d0
      alphasmz = 0.118d0
      cf = 4d0/3d0
      eps = 1d-10
      i = (0d0, 1d0)

c      mt = 175d0
c      mb = 4.5d0
      delrholimit = 1.3d-3

      xmw = mw
      xmz = mz
      ymz = mz
      yalphasmz = alphasmz

c -----------------------------------------------------------------
c
c  switches
c  ========
c
c  selec2 = 1: full 1-loop + 2-loop QCD with top pole mass
c           2: same as 1, but in addition with
c                         Yukawa term added for light Higgs
c           3: full 1-loop + 2-loop QCD with running top mass
c           4: same as 3, but in addition with
c                          Yukawa term added for light Higgs
c              The choice for the top mass (pole/running) will
c              also be applied on the top mass appearing in
c              the stop mass matrix
c
c  selec3 = 1: input is Msusy, MtLR, ...
c              output is MSt1, MSt2, MSb1, MSb2, stt, stb, ...
c           2: input is MSt2, delmst, stt
c              output is MSt1, MSb1, MSb2, stb, ...
c
c -----------------------------------------------------------------

c     single point calculation with online parameter input

      selec=0
      

 90   continue

      selec5 = 1
      lleselec1 = 1
      mpgut = 1
      mtmsbarselec = 1
      msbarselec = 2
      msbarselecsave = msbarselec
      ii=4
      selec3=1
      print1=0
      print2=1
      delrholimit=0
      selec2 = ii
      write(*,*)
      if ((ii.ne.1).and.(ii.ne.2).and.(ii.ne.3).and.(ii.ne.4)) then
         write(*,*) "WRONG INPUT FOR DEPTH OF CALCULATION"
         goto 90
      endif
      if ((selec3.ne.1).and.(selec3.ne.2).and.
     $    (selec3.ne.3).and.(selec3.ne.4)) then 
         write(*,*) "WRONG INPUT FOR INPUT SELECTION"
         goto 90
      endif
      if (selec3.le.2) then
         selec4 = 1
      else
         selec4 = 2
      endif
c      if ((selec4.ne.1).and.(selec4.ne.2)) then 
c         write(*,*) "WRONG INPUT FOR MT IN STOP MASS MATRIX"
c         goto 90
c      endif
      if (delrholimit.eq.0d0) delrholimit = 1.3d-3
      if ((print1.ne.0).and.(print1.ne.1))  then
         write(*,*) "WRONG INPUT FOR PARAMTER TEST OUTPUT"
         goto 90
      endif
      if ((print2.ne.0).and.(print2.ne.1)) then 
         write(*,*) "WRONG INPUT FOR SFERMION OUTPUT"
         goto 90
      endif

      mtselec = 0
      goto 110

 100  continue
      write(*,*)
      write(*,*) "What next? (0: new calculation // 1: setup)"
      read(*,*) selec
      if (selec.eq.1) goto 90

 110  continue


c --> Input of parameters

      if (selec3.eq.1) then
c --> Input: OS, Msusy, Xt, Xb

c      read(*,*) tb, msusytl, msusytr, msusybr, mtlr, mblr, 
c     $          mt, mb, mgl, mue, mmm, ma
c      if (tb.eq.0d0) goto 90
      
      msusy = msusytl
      msusybl = msusytl
      if (msusytr.eq.0d0) msusytr = msusy
      if (msusybr.eq.0d0) msusybr = msusy
      if (mt.eq.0d0) mt = 175d0
      if (mt.eq.1d0) mt = 174.3d0
      if (mb.eq.0d0) mb = 4.5d0
      if (mb.eq.1d0) mb = 2.97d0
      if (mgl.eq.0d0) mgl = 500d0
      if (mgl.eq.1d0) mgl = msusy
      if (mue.eq.1d0) mue = -200d0
      if (mue.eq.2d0) mue = -msusy
      if (mmm.eq.1d0) mmm = 400d0
      if (mmm.eq.2d0) mmm = msusy

      else
         write(*,*) 'internal error for selec3... stopping'
         stop
      endif

      xmt = mt


c --> Evaluating the OS parametes (if necessary...)

      if (selec3.eq.1) then
c --> Input: OS, Msusy, Xt, Xb

      au = mtlr + mue/tb
      if (mblr.eq.1d0) then
         ad = au
         mblr = ad - mue * tb
      endif
      ad = mblr + mue * tb
      mlrt = mtlr
      mlrb = mblr

      else
         write(*,*) 'internal error for selec3... stopping'
         stop
      endif
            



      ymb = mb

      if (print1.eq.0) then
      write(*,*)
      write(*,*) "Your OS parameters:"
      write(*,*) "MT, Msusy(top-left), Msusy(top-right), Xt, At"
      write(*,*) "MB, Msusy(bot-left), Msusy(bot-rigth), Xb, Ab"
      write(*,*) "tb, Mgl, Mu, M2, MA"
      write(*,*) real(mt), real(msusytl), real(msusytr), real(mtlr),
     $                                                    real(au)
      write(*,*) real(mb), real(msusybl), real(msusybr), real(mblr),
     $                                                    real(ad)
      write(*,*) real(tb), real(mgl), real(mue), real(mmm), real(ma)
c      write(*,*)
      endif
      if (selec3.ne.1) then
      if (   (real(mst1).le.65d0).or.(real(mst2).le.65d0).
     $    or.(real(msb1).le.65d0).or.(real(msb2).le.65d0)) then
         write(*,*) "WARNING - WARNING - WARNING - WARNING"
         write(*,*) "experimental excluded sfermion masses:"
         write(*,*) "MSt1, MSt2: ", real(mst1), real(mst2)
         write(*,*) "MSb1, MSb2: ", real(msb1), real(msb2)
         write(*,*) "WARNING - WARNING - WARNING - WARNING"
      else
        if (print2.eq.0) then
         write(*,*) "The Sfermion masses:"
         write(*,*) "MSt1, MSt2: ", real(mst1), real(mst2)
         write(*,*) "MSb1, MSb2: ", real(msb1), real(msb2)
         ctt = dsqrt(1d0 - stt**2)
         ctb = dsqrt(1d0 - stb**2)
         write(*,*) "cos(mixing angles): ", real(ctt), real(ctb)
         write(*,*) "sin(mixing angles): ", real(stt), real(stb)
        endif
      endif
      endif



      call feynhiggsfastsub()
      write(*,*) "-------------------------------------------------"
c      write(*,*) "-------------------------------------------------"
      write(*,*) "The results: light Higgs    heavy Higgs     alpha"
c      write(*,*) "-------------------------------------------------"
      if ((real(mst1).ge.65d0).and.(real(msb2).ge.65d0)) then
         write(*,*) "mh-tree : ", real(mlh),real(mhh), real(alpha)
c         write(*,*) "-------------------------------------------------"
c         write(*,*) "mh-1loop: ", real(mlhlle1) ,
c     $           "                              (formula for MA >> MZ)"
         write(*,*) "mh-1loop: ", real(mlhllediag1),real(mhhllediag1),
     $                            real(alphadiag1),
     $              "(mtr diag.)"
c         write(*,*) "-------------------------------------------------"
c         write(*,*) "mh-2loop: ", real(mlhlle2) ,
c     $           "                              (formula for MA >> MZ)"
         write(*,*) "mh-2loop: ", real(mlhllediag2),real(mhhllediag2),
     $                            real(alphadiag2),
     $              "(mtr diag.)"
c         write(*,*) "-------------------------------------------------"
         write(*,*) "charged Higgs, tree: ", real(mhptree)
         write(*,*) "             1-loop: ", real(mhp)
      else
         write(*,*) "unphysical sfermion masses:"
         write(*,*) "MSt1, MSt2: ", real(mst1), real(mst2)
         write(*,*) "MSb1, MSb2: ", real(msb1), real(msb2)
         goto 100
      endif


 99   continue

      write(*,*) "-------------------------------------------------"
c      write(*,*) "-------------------------------------------------"
      call delrho(mst1, mst2, stt, msb1, msb2, stb, gf, as, 
     $            cf, gs, el, mz, mw,
     $            delrho1loop, delrho2loopgluon, delrho2loopgluino)
      delrhores = delrho1loop + delrho2loopgluon
      if (dabs(delrhores).gt.delrholimit) then
         write(*,*) 'WARNING: Delta rho > experimental limit'
      endif
c      write(*,*) 'Delta rho 1-loop         : ', delrho1loop
c      write(*,*) 'Delta rho 2-loop (gluon) : ', delrho2loopgluon
c      write(*,*) 'Delta rho total          : ', delrhores
      write(*,*) "-------------------------------------------------"

c      goto 100


      end
